<script setup>
import {defineProps, computed, ref} from "vue"
import {defineEmits,watch} from "vue"
import axios from 'axios';
import { notify } from "@kyvg/vue3-notification";
import Multiselect from "@vueform/multiselect"


// import { useStore } from '@/store/useMyStore';
// const useMyStore = useStore();
// const object_level = useMyStore.object_level;



// const searchData = reactive({
//   channel_type_id: "",
//   channel_type_name: "",
//   plan_id: "",
//   plan_name: "",
//   object_type: "",
//   object_level: "",
//   current_page: 0,
//   paging: true
// });
const emit = defineEmits(['onOk', 'update:itemDetail'])
const props = defineProps({
  itemDetail: {
    type: Object,
    required: true,
    default: () => ({}),
  },
  optionsobjectlevel: {
    type: Object,
    required: true,
    default: () => ({}),
  },
});

const itemDetail = computed({
  get() {
    return props.itemDetail || {};
  },
  set(value) {
    emit('update:itemDetail', value)
  }
});

const formattedObjectType = computed(() => {
  const objectType = itemDetail.value.object_type;
  if (objectType === 1) {
    return 1;
  } else if (objectType === 2) {
    return 2;
  } else {
    return "Không rõ";
  }
});
const formattedObjectLevel = computed(() => {
  const objectLevel = itemDetail.value.object_level;
  if (objectLevel === 1) {
    return 1;
  } else if (objectLevel === 2) {
    return 2;
  } else if (objectLevel === 3) {
    return 3;
  }  else if (objectLevel === 4) {
    return 4;
  }  else if (objectLevel === 5) {
    return 5;
  }  else if (objectLevel === 6) {
    return 6;
  }  else {
    return "Không rõ";
  }
});
const isSaving = ref(false);
const confirmEditChannel = async () => {
   try {
    isSaving.value = true;
    const response = await axios.post('/api/plan/edit', {
      channel_type_id: itemDetail.value.channel_type_id,
      plan_name: itemDetail.value.plan_name,
      object_type: itemDetail.value.object_type, 
      object_level: itemDetail.value.object_level, 
      plan_id: itemDetail.value.plan_id,
    });
    isSaving.value = false;
    if (response && response.data.status.message && response.data.status.message.length > 0) {
      notify({
        type: 'error',
        title: "Edit Error",
        text: response.data.status.message,
        duration: 10000,
      });
    } else {
      notify({
        type: 'success',
        title: "Edit Successful",
        duration: 10000,
      });
    }
  } catch (error) {
    isSaving.value = false;
  }
};
const selectedObjectType = ref(props.initialObjectType);
watch(() => props.initialObjectType, (newInitialObjectType) => {
      selectedObjectType.value = newInitialObjectType;
    });

//themmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
const optionsobjectlevel = [
  {
    title: "PDV de Bitel (Celular)",
    value: 1,
  },
  {
    title: "PDV de Bitel (solo recarga)",
    value: 2,
  },
  {
    title: "PDV de Bitel (Atencion de Cliente)",
    value: 3,
  },
  {
    title: "PDV del Distribuidor",
    value: 4,
  },
  {
    title: "PDV del Mercado libre",
    value: 5,
  },
  {
    title: "PDV de Bitel (viaje + hotel)",
    value: 6,
  },
];

const options = [
  {
    title: "SHOP",
    value: "1",
  },
  {
    title: "STAFF",
    value: "2",
  },
];
</script>
<template>
  <div class="row col-md-12 p-b-15">
    <div class="col-md-6 text-center">
      <div class="row">
        <label class="col-md-5 form-label">{{ $t("HOME.SEARCH.MAP.TYPE_CHANNEL_TYPE") }}:</label>
        <input
          v-model="itemDetail.channel_type_name"
          class="form-control-input col-md-7"
          type="text"
          style="align-items: center;box-sizing: border-box;cursor: pointer;display: flex;justify-content: flex-end;margin: 0 auto;min-height: calc(var(--ms-border-width, 1px)*2 + var(--ms-font-size, 1rem)*var(--ms-line-height, 1.375) + var(--ms-py, .5rem)*2);outline: none;position: relative;width: 100%;"
        />
      </div>
    </div>
    <div class="col-md-6 text-center">
      <div class="row">
        <label class="col-md-5 form-label">{{ $t("PLAN_NAME") }}:</label>
        <input
          v-model="itemDetail.plan_name"
          class="form-control-input col-md-7"
          type="text"
          style="align-items: center;box-sizing: border-box;cursor: pointer;display: flex;justify-content: flex-end;margin: 0 auto;min-height: calc(var(--ms-border-width, 1px)*2 + var(--ms-font-size, 1rem)*var(--ms-line-height, 1.375) + var(--ms-py, .5rem)*2);outline: none;position: relative;width: 100%;"
        />
      </div>
    </div>
  </div>
  <div class="row col-md-12 p-b-15">
    <div class="col-md-6 text-center">
      <div class="row">
        <label class="col-md-5 form-label">{{ $t("OBJECT_TYPE") }}:</label>
        <multiselect
            v-model="formattedObjectType"
            deselect-label="Can't remove this value"
            track-by="title"
            label="title"
            :placeholder="$t('SELECT_ONE')"
            :options="options"
            :searchable="false"
            :allow-empty="false">
        </multiselect>
      </div>
    </div>
    <div class="col-md-6 text-center">
      <div class="row" >
        <label class="col-md-5 form-label">{{ $t("OBJECT_LEVEL") }}:</label>
        <multiselect
            v-model="formattedObjectLevel"
            deselect-label="Can't remove this value"
            track-by="title"
            label="title"
            :placeholder="$t('SELECT_ONE')"
            :options="optionsobjectlevel"
            :searchable="false"
            :allow-empty="false">
        </multiselect>
      </div>
    </div>

  </div>
  <div class="row col-md-12 p-b-15">
  </div>
  <div class="row col-xs-12" >
    <button id="add_btn" type="submit" class="btn btn-primary ng-binding" style="width: 175px; margin: 0px auto; text-align: center;" @click="confirmEditChannel">{{ $t("CONFIRM") }} </button>
  </div>
</template>
<style scoped>
.form-label {
  text-align: start;
}
.form-control-input {
  height: 30px;
  border: 1px solid #dee2e6;
  border-radius: 6px;
}
.form-control-date {
  width: 58%;
  padding: 0px;
  height: 35px;
}
</style>
